<?
/*
Functions to parse Hershey vector fonts, as downloaded from
http://local.wasp.uwa.edu.au/~pbourke/dataformats/hershey/
*/

function get_mapping($file) {
    $f=fopen($file,"r");
    if ($f===false) die("Couldn't open $file.");
    $idx=32;
    while(!feof($f)) {
	$r=trim(fgets($f,1024));
	if (strpos($r,"-")===false) { //line with spaces
	    $n=split(' +',$r);
	    foreach($n as $sym) {
		$mapping[$idx++]=$sym;
	    }
	} else { //line in a-b-form
	    $n=explode('-',$r);
	    for ($x=$n[0]; $x<=$n[1]; $x++) {
		$mapping[$idx++]=$x;
	    }
	}
    }    
    fclose($f);
    return $mapping;
}

function hval($c) {
    return ord($c)-ord('R');
}

function load_font($file) {
    $f=fopen($file,"r");
    if ($f===false) die("Couldn't open $file!\n");
    while (!feof($f)) {
	$r=rtrim(fgets($f,1024));
	if (strlen($r)>=71) $r.=rtrim(fgets($f,1024));
	if (strlen($r)>=142) $r.=rtrim(fgets($f,1024));
//	echo strlen($r)."\n";
//	echo $r."\n";
	$i=intval(trim(substr($r,0,5)));
	$fnt[$i]["nocoord"]=substr($r,5,3)-1;
	$fnt[$i]["left"]=hval(substr($r,8,1));
	$fnt[$i]["right"]=hval(substr($r,9,1));
	$fnt[$i]["coords"]=substr($r,10);
//	echo "Index $i:\n";
//	print_r($fnt[$i]);
    }
    return $fnt;
}

function get_char($c,$map,$font,$sc) {
    $n=$map[ord($c)];
    if ($n==0) {
	echo "No mapping for $c\n";
	return array();
    }
    $r["w"]=($font[$n]["right"]-$font[$n]["left"])*$sc;
//    $r["r"]=$font[$n]["right"];
//    $r["l"]=$font[$n]["left"];
    $r["h"]=20*$sc; //??
    $p=0;
    $ec=$font[$n]["coords"];
    $r["coord"]=array();
    for ($x=0; $x<$font[$n]["nocoord"]*2; $x+=2) {
        if (substr($ec,$x,2)==" R") { //raise pen
    	    $p=0;
	} else {
	    $r["coord"][$x/2]["x"]=(hval(substr($ec,$x,1))-$font[$n]["left"])*$sc;
	    $r["coord"][$x/2]["y"]=hval(substr($ec,$x+1,1))*$sc;
	    $r["coord"][$x/2]["d"]=$p;
	    $p=1;
	}
    }
    return $r;
}

function draw_string($str,$map,$font,$xs,$ys,$xe,$ye,$sc) {
    $x=$xs; $y=$ys;
    $r=array();
    $i=0;
    for ($n=0; $n<strlen($str); $n++) {
	$c=get_char(substr($str,$n,1),$map,$font,$sc);
	print_r($c);
	if (($x+$c["w"])>$xe) {
	    $x=$xs;
	    $y+=$c["h"];
	}
	if (($y+$c["h"])>$ye) return $r;

	foreach($c["coord"] as $coord) {
	    $r[$i]["x"]=$coord["x"]+$x;
	    $r[$i]["y"]=$coord["y"]+$y;
	    $r[$i]["d"]=$coord["d"];
	    $i++;
	}
	$x+=$c["w"];
	echo "x,y: $x,$y\n";
    }
    return $r;
}
?>